	list p=12f683
	#include <p12f683.inc>
	radix dec

;falta optimizar codigo.. con defines.. y quitando las instruccions bsf de un bit.. cuando hay qu emodificar mas de uno en un byte...!!

#define		led	GPIO,1
#define		enab	GPIO,0
#define		forward GPIO, 3
#define	    changef flags,0
;ensambla con mpasmw!!

; Microcontroller model: PIC12F683
; Clock frequency: 20.0 MHz
;Variables**************************************
duty equ 0x20	;bits ms significativos
s100 equ 0x21  ;cada 100 un segundo
s equ 0x22     ; numeros de segundos que lo queremos activo	
tpr2 equ 0x23	;valor pre2 para calculo d frecuencia
flags equ 0x24  ;para guardar flas

	ORG 0x0000	
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO init
	ORG 0x0004	;Tratamiento de interrupciones... no hace nada
	goto interrupt
	

; Begin of program
init:
	clrf PIR1   ; limpiamos interrupciones
	movlw b'11000000'  ; set GIE y PEIE
	movwf INTCON
	BSF STATUS,RP0
	movlw b'00000011'  ; set TMR1IE:
	movwf PIE1
; 3: TRISIO = 0
	CLRF TRISIO
	bsf TRISIO, 3  
; 4: AllDigital
	CLRF ANSEL
	BCF STATUS,RP0
	MOVLW 0x07
	MOVWF CMCON0
; 5: WPU = %000000  'internal pull-up disabled
	BSF STATUS,RP0
	CLRF WPU
	BCF STATUS,RP0
; 12: GPIO = 0  'everything off
	CLRF GPIO
; 13: 
; 14: enab = 1
	BSF enab
; 15: 
;CARGO DUTY
; a mi me sale 131.. no 128... 128 sera BCF de los dos bits??
	MOVLW 0x20    ; generador automatico de codigo 00100001 21
	MOVWF duty

;inicio forzando un cambio de frecuencia para que cargue
	bsf changef

;5 segundos cada prueba
	call resets100
	call resets

;INICIO PWM
;CARGO FRECUENCIA
	btfsc  forward
	goto backlowf
	goto forwlowf
	
backlowf: MOVLW d'52'
	 goto loadtpr2
forwlowf: MOVLW d'66' 	
loadtpr2:movwf tpr2
	;call loadpr2
	call initpwm
	call resettmr1
LOOP:
	GOTO LOOP
; End of program  todo pasa en interrupciones del contador


;***********************************************
;***********************************************
resets100:
;usando prescaler 8 podra conseguir que contara hasta 10... pero da igual..
	;MOVLW d'100'   
	MOVLW d'100'   
	movwf s100
	return
resettmr1:
	;50000... 100 veces 50000= 5000000; 5000000 *0,2us=1s
	;cuenta hacia alante hasta FFFF=65535-50000=3cB0=15536... mas o menos.. sin tener en cuenta los tiempos de ejecucion
;	MOVLW 0x3c  
	MOVLW 0x3c  
	movwf TMR1H
	movlw 0Xb0 
	movwf TMR1L
	movlw 0x01
	movwf T1CON ;empieza a contar
	return
resets:
;	MOVLW d'5'
	MOVLW d'2'
	movwf s	
	return
loadpr2:
	movf tpr2,w
	BSF STATUS,RP0
	MOVWF PR2
	BCF STATUS,RP0
	return
initpwm:
;Step 1 microchip
	BSF STATUS,RP0
	BSF TRISIO,2
	BCF STATUS,RP0
;Step 2 microchip
	call loadpr2

;Step 3 microchip
	MOVLW 0x0C ;1100    autocodigo dice que 1c: 00011100  cambia el less significant bit del duty
	IORWF CCP1CON,F  ;yo preferiria ponerlo todo... as me arriesgo adejarlo activo en nivel alto si b1=1 en registro

;*************************codigo viejo
;	CLRF CCPR1L
	; reseteo la parte alta del duty cycle
;	BCF CCP1CON,DC1B1
;	BCF CCP1CON,DC1B0
	; reseteo la parte baja del duty cycle
;Step 4 microchip
	call loadduty
;Step 5 microchip
	BCF T2CON,T2CKPS0
	BCF T2CON,T2CKPS1
	;Pongo el preescaler a cero
	BSF T2CON,TMR2ON
	;Pongo el timer a funcionar
;Step 6: Se activa solo tras primer ciclo en interrupcion
;	BSF STATUS,RP0
;	BCF TRISIO,2
;	BCF STATUS,RP0
	return
loadduty:
	;Vamos a considerar resoluciones siempre de 8 bits... luego los dos bits ms significativos no importa... a cero
	; por simplificar bits menos significativos a cero
	BSF CCP1CON,DC1B0
	BSF CCP1CON,DC1B1
	MOVF duty,w
	MOVWF CCPR1L
	return	

interrupt:
	; como solo he flag la interrupcion por tmr1f, entiendo que solo sale por esto
	btfsc PIR1, TMR2IF  ; si no es el flag del TMR2 (el normal pq salta en cada vencimiento de pr2), entonces salta y trata el timer del 1... que lleva ms faena
	goto intTPR
	bcf PIR1, TMR1IF
	
	DECFSZ s100,f
	goto endint
	call resets100
	
	DECFSZ s,f
	goto endint2	
	call resets
	
	decf tpr2,f
;	movlw d'53'   ;pasada la frecuencia 53 no quiero buscar ms
;	movlw d'44'   ;pasada la frecuencia 53 no quiero buscar ms
	btfsc  forward
	goto backupf
	goto forwupf
	
backupf: MOVLW d'44'
	 goto loadlimit
forwupf: MOVLW d'53' 	
loadlimit: bsf changef 
;YO LO PONDRIA AL FINAL el change f... justo tras el call pwm... PARA EVITAR QUE SE ACTIVE SALIDA ANTES DE TERMINAR ESTO
;... AUNQUE COMO TODO PASA DENTRO DE LA INTERRUPCION Y NO HE DADO RETFIE.. NO DEBERIA PASAR NADA... BUENO SI.. QUE REALMENTE NO SE ACTIVA CUNADO EL TMR2 EMPIEZA EN CERO....
;En realidad, al hacerlo as provoco que el primer periodo sea mas corto .. pq no inicia con tmr2=0... si lo pongo al final, provoco un ltimo periodo de la frecuencia anterior, mas larga (creo)
	subwf tpr2,w
	BTFSC STATUS,Z
	goto close  ;si la resta da cero se acaba todo
;	call loadpr2
;	call initpwm
;	call loadduty
	call initpwm
endint2:MOVLW 0x02  ;hago on toogle del led daca segunfo
	XORWF GPIO,F
endint:	call resettmr1
	RETFIE
	; hacer call a rest tmr... con decrementos, etc.
	;goto LOOP	
close: clrf INTCON  ;desactivo interrupciones... se quedar encendido o paagado.. dependiendo ultimo valor
       BCF enab  ; paro motores
       BCF led
       BCF T2CON,TMR2ON
       clrf CCP1CON ;paro el pwm
	BSF STATUS,RP0
	BCF TRISIO,2
	BCF STATUS,RP0
       BCF GPIO, 2
;       sleep 		
	goto close
intTPR: bcf PIR1, TMR2IF
		btfss changef
		RETFIE
;step 6 microchip
		bcf changef
		BSF STATUS,RP0
		BCF TRISIO,2
		BCF STATUS,RP0
		RETFIE

; Configuration word settings
	ORG 0x2007
	DW 0x31C2	
; End of listing
      END
